/*
 * Test error actions.
 */

#include <iostream>
#include <stdio.h>

using namespace std;

#define DIGIT   0x01
#define PLUS    0x02
#define MINUS   0x04
#define DECIMAL 0x08

int expt = 0;

%% ErrAct
	struct {};

	action err_start { printf("err_start\n"); }
	action err_all { printf("err_all\n"); }
	action err_finish { printf("err_finish\n"); }
	action err_out { printf("err_out\n"); }

	action eof_start { printf("eof_start\n"); }
	action eof_all { printf("eof_all\n"); }
	action eof_finish { printf("eof_finish\n"); }
	action eof_out { printf("eof_out\n"); }

	main := ( 'hello' 
			>!err_start $!err_all @!err_finish %!err_out
			>~eof_start $~eof_all @~eof_finish %~eof_out 
		) '\n';
%%

#define BUFSIZE 1024

int main()
{
	char buf[BUFSIZE];

	while ( fgets( buf, sizeof(buf), stdin ) != 0 ) {
		/* Take the first character to be the length. */
		int len = buf[0] - '0';
		ErrAct errAct;

		errAct.init();
		errAct.execute( buf+1, len );
		if ( errAct.finish() > 0 )
			cout << "ACCEPT" << endl;
		else
			cout << "FAIL" << endl;
	}
	return 0;
}
